;============================================================
;MAIN NEWACTIONTYPE INITIALIZATION PROCS AND MACROS (UNIQUE TO)
;============================================================

;============================================================
;MACROS
;============================================================

;============================================================
MACRO ALLOCAT _size {	;memory allocation
      push _size
      call [YAPAXI]	      ;allocates memory for instance
      add esp,4
      test eax,eax
	   jz UnableToAllocateMem
      mov edi,eax	      ;store pointer in edi
      }
;============================================================
MACRO GETVALUE EntryValue,_number {	;T-Script entry fetch
      push _number	      ;edi and ebp must be set up properly
      push DWORD [ebp-36]     ;passed value of edi
      push DWORD [ebp-32]     ;passed value of esi
      mov eax,[ebp-28]	      ;passed value of ebx
      add eax,EntryValue      ;table displacement for the T-Script value
      push eax
      call [GetEntryValueProc]
      add esp,16
      }
;============================================================
;retrieves and stores value from returned object
;_member is the member in the destination object

MACRO SETVALUE ValueType,_member {
	local WrongValueType
	local NoObject
test eax,eax
     jz NoObject
cmp DWORD [eax+4],ValueType
     jnz WrongValueType
	if ValueType=value_string
	mov eax,[eax+40h]
	else
	mov eax,[eax+28h]	;if string, this is only string length (without null-terminator)
	end if			;if other value, this is direct value
mov [edi+((_member-1)*4)],eax
jmp NoObject
WrongValueType:
xor eax,eax
NoObject:
}				;eax has value if needed
;============================================================
MACRO SETVALUE2 ValueType {	;same as above, but only returns pointer in eax
	local WrongValueType
	local NoObject
test eax,eax
     jz NoObject
cmp DWORD [eax+4],ValueType
     jnz WrongValueType
	if ValueType=value_string
	mov eax,[eax+40h]
	else
	mov eax,[eax+28h]	;if string, this is only string length
	end if			;if other value, this is direct value
jmp NoObject
WrongValueType:
xor eax,eax
NoObject:
}
;============================================================
;MACRO GETGROUP EntryValue,_number, {     ;T-Script entry fetch
;      push _number            ;edi and ebp must be set up properly
;      push DWORD [ebp-36]     ;passed value of edi
;      push DWORD [ebp-32]     ;passed value of esi  -> USE CUSTOM VALUE
;      mov eax,[ebp-28]        ;passed value of ebx
;      add eax,EntryValue      ;table displacement for the T-Script value
;      push eax
;                               ;param1 = address for DWORD for group ID
;      call [GetGroupIDValueProc]      ;returns al=false if not found/error
;      add esp,20
;      }
;============================================================
MACRO MOVESTRING dest,source,length {
      mov ecx,length
      push esi
      push edi
      mov esi,source
      lea edi,dest
      rep movsb 	   ;move string to allocated memory
      pop edi
      pop esi
      }
;============================================================
;returns value in eax.
;If no error, ecx is non-null and contains structure (contains
;string length if string). If not found or if error, ecx is null.
MACRO GETVALUEEXT EntryOffsetValue,GroupIDValue,MiscValue,CountValueAddr,ValueType {
      local InvalidEntry
      push DWORD [CountValueAddr]
      push MiscValue
      push GroupIDValue
      push EntryOffsetValue
      call [GetEntryValueProc]
      xor ecx,ecx
      add esp,16
      test eax,eax
	   jz InvalidEntry
      cmp DWORD [eax+4],ValueType
	  jnz InvalidEntry
      inc DWORD [CountValueAddr]
	if ValueType=value_string
	cmp DWORD [ecx+28h],0	;if string, only return if size is longer than zero
	    jz InvalidEntry
	mov ecx,eax
	mov eax,[ecx+40h]
	else
	mov ecx,eax
	mov eax,[ecx+28h]	;if string, this is only string length (without null-terminator)
	end if			;if other value, this is direct value
      InvalidEntry:
      }
;============================================================

;============================================================
;PROCS
;============================================================

;====================================================================
GetTripletValues:     ;retrieves three consecutively-arranged script values of same type (i.e., X,Y,Z)
;====================================================================
;param1 = offset for first value
;param2 = group ID value
;param3 = misc. value (unknown)
;param4 = address of a variable that holds group value counter
;param5 = value type
;param6 = pointer for results
;returns non-zero in eax if all three values were successfully found

;value 1
      mov ecx,[esp+16]
      mov edx,[esp+12]
      push DWORD [ecx]
      mov eax,[esp+8]
      mov ecx,[esp+12]
      invoke GetEntryValueProc,eax,ecx,edx
      add esp,16
      test eax,eax
      mov ecx,[esp+20]
	   jz GetTripletValues_Fail
      cmp DWORD [eax+4],ecx
	  jnz GetTripletValues_Fail

      mov edx,[eax+28h]
      mov eax,[esp+24]
      mov ecx,[esp+16]
      mov [eax],edx		;store value 1

      inc DWORD [ecx]

;value 2

      mov edx,[esp+12]
      push DWORD [ecx]
      mov eax,[esp+8]
      mov ecx,[esp+12]
      add eax,8
      invoke GetEntryValueProc,eax,ecx,edx
      add esp,16
      test eax,eax
      mov ecx,[esp+20]
	   jz GetTripletValues_Fail
      cmp DWORD [eax+4],ecx
	  jnz GetTripletValues_Fail

      mov edx,[eax+28h]
      mov eax,[esp+24]
      mov ecx,[esp+16]
      mov [eax+4],edx		  ;store value 2

      inc DWORD [ecx]

;value 3

      mov edx,[esp+12]
      push DWORD [ecx]
      mov eax,[esp+8]
      mov ecx,[esp+12]
      add eax,16
      invoke GetEntryValueProc,eax,ecx,edx
      add esp,16
      test eax,eax
      mov ecx,[esp+20]
	   jz GetTripletValues_Fail
      cmp DWORD [eax+4],ecx
	  jnz GetTripletValues_Fail

      mov edx,[eax+28h]
      mov eax,[esp+24]
      mov ecx,[esp+16]
      mov [eax+8],edx		  ;store value 2

      inc DWORD [ecx]

      mov eax,TRUE

ret 24

GetTripletValues_Fail:
      xor eax,eax

ret 24