align 16
;========================================================
ATXDRV_MAIN_RT_PROC:
;========================================================
StraightEmitterTargetDistance_ATXDRV	    equ     [float_100]

cmp [IsInGame_BOOL],0
     jz NoATXDRV_MAIN_RT_PROC
cmp [IsInConsole_BOOL],1
     jz NoATXDRV_MAIN_RT_PROC

      mov ebx,[ATXDRV_CURROBJ]		;ebx = current ATXDRV ActionType object
      call [ATXDRV_CURRENTRTMETHOD]

NoATXDRV_MAIN_RT_PROC:
ret

;========================================================
UseATXDRV_RT_Type_1:
;========================================================
      invoke GetTickCount
;key handler (acceleration handler)
      sub eax,[ATXDRV_KeyLastTick]
      cmp eax,[ebx+atxdrv_type1.Tick]
	  jb NoATXDRVKeyHandlerProcType1
      push eax
      add [ATXDRV_KeyLastTick],eax
      fild DWORD [esp]
      fmul [float_0_001]
      add esp,4
      fstp [ATXDRV_KeyTime]
	  call ATXDRV_KEYHANDLER_TYPE1
 NoATXDRVKeyHandlerProcType1:
ret

;========================================================
ATXDRV_KEYHANDLER_TYPE1:
;========================================================

;fetch current velocity values
      mov eax,[ebx+atxdrv_type1.Instance]
      mov edx,[eax+28h]
      mov ecx,[edx+0Ch]
      push eax
      push ATXDRV_INITIALVELOCITY
      call GetInstancePhysicsVelocity
      ;test eax,eax
      ;     jz ATXDRV_Type1_Unfreeze

;convert Target instance's current orientation from quats to angles (-1.0 to +1.0)
;-> stored in Temp_Fly_Buffer2
      mov eax,[ebx+atxdrv_type1.Instance]
      push Temp_Fly_Buffer3		      ;(default/no importance here)
      lea ecx,[eax+3Ch] 		      ;source values (quat)
      push Temp_Fly_Buffer2		      ;param 1 = dest for values (returned in eax)
      call CONVERT_TO_FACING_PROC_010	      ;2 params
;ATXDRV_INITVELVECTOR

;convert Target instance's current orientation from angles to [x,y,z] unit vector
      fld DWORD [eax+8] 	   ;z angle facing value
      mov ecx,eax
      fmul DWORD [ebx+atxdrv_type1.MvtZAngleMul]	;multiplier for z angle (typically 0.000000)
      mov edx,ATXDRV_CurrentVectorDir
      fstp DWORD [eax+8]
      ;call FacingToVector_A

;calculate object's velocity in the direction of its orientation
; -> because director vector is assumed to be a unit vector, calculating
;    the component of a vector on this one is equal to the dot product (because
;    the dir. vector length as divisor will always be 1).

      mov ecx,ATXDRV_INITIALVELOCITY.XVelocity
      mov edx,ATXDRV_CurrentVectorDir
      mov eax,ATXDRV_CurrentVectorVal
      call VectorDotProduct
      mov eax,[ATXDRV_CurrentVectorVal]
      mov [ATXDRV_CurrentVectorVal_Saved],eax

;get base key list (in EXE)
      mov edi,[KEY_LIST_ADDR]	     ;must be in edi for all key tests

;------------------------
;forward fast key
;------------------------
      invoke GetAsyncKeyState,[edi+80]
      test eax,80000000h
	   jz ATXDRV_Type1_NoFWDFast

	   fld [ebx+atxdrv_type1.FWDFast]
	   fmul [ATXDRV_KeyTime]

	   fld [ebx+atxdrv_type1.FastLimit]
	   fsub [ATXDRV_CurrentVectorVal]
	   fcom [float_0]
	   fstsw ax
	   test ah,41h			       ;speed limit exceeded?
		jnz ATXDRV_Type1_NoFrontBackMVTPop2
	   fcomp			       ;near limit?
	   fstsw ax
	   test ah,41h			       ;limitvelocitydifference > accvelocitydifference?
		jnz ATXDRV_Type1_FWDUseLimit   ;set velocity to exact limit if not

	   fadd [ATXDRV_CurrentVectorVal]
	   fstp [ATXDRV_CurrentVectorVal]      ;add velocity difference for new velocity
      jmp ATXDRV_Type1_NoBackSlow
      ATXDRV_Type1_FWDUseLimit:
	   mov eax,[ebx+atxdrv_type1.FastLimit]
	   fstp st0
	   mov [ATXDRV_CurrentVectorVal],eax   ;set new velocity to exact limit
      jmp ATXDRV_Type1_NoBackSlow
      ATXDRV_Type1_NoFWDFast:

;------------------------
;forward slow key
;------------------------
      invoke GetAsyncKeyState,[edi+88]
      test eax,80000000h
	   jz ATXDRV_Type1_NoFWDSlow

	   fld [ebx+atxdrv_type1.FWDSlow]
	   fmul [ATXDRV_KeyTime]

	   fld [ebx+atxdrv_type1.SlowLimit]
	   fsub [ATXDRV_CurrentVectorVal]
	   fcom [float_0]
	   fstsw ax
	   test ah,41h			       ;speed limit exceeded?
		jnz ATXDRV_Type1_NoFrontBackMVTPop2

	   fcomp			       ;near limit?
	   fstsw ax
	   test ah,41h			       ;limitvelocitydifference > accvelocitydifference?
		jnz ATXDRV_Type1_FWDSlowUseLimit  ;set velocity to exact limit if not

	   fadd [ATXDRV_CurrentVectorVal]
	   fstp [ATXDRV_CurrentVectorVal]      ;add velocity difference for new velocity

      jmp ATXDRV_Type1_NoBackSlow
      ATXDRV_Type1_FWDSlowUseLimit:
	   mov eax,[ebx+atxdrv_type1.SlowLimit]
	   fstp st0
	   mov [ATXDRV_CurrentVectorVal],eax   ;set new velocity to exact limit
      jmp ATXDRV_Type1_NoBackSlow
      ATXDRV_Type1_NoFWDSlow:

;------------------------
;backward key (note: all struc values should be negative)
;------------------------
      invoke GetAsyncKeyState,[edi+96]
      test eax,80000000h
	   jz ATXDRV_Type1_NoBackSlow

	   fld [ATXDRV_CurrentVectorVal]
	   fcomp [float_0]
	   fstsw ax
	   test ah,41h			       ;going forward (braking time)?
		jnz ATXDRV_Type1_BackBrake

	   fld [ebx+atxdrv_type1.BackSlow]
	   fmul [ATXDRV_KeyTime]

	   fld [ebx+atxdrv_type1.BackLimit]
	   fsub [ATXDRV_CurrentVectorVal]
	   fcom [float_0]
	   fstsw ax
	   test ah,01h				  ;backward speed limit exceeded?
		jz ATXDRV_Type1_NoFrontBackMVTPop2

	   fcomp				  ;near limit?
	   fstsw ax
	   test ah,01h				  ;limitvelocitydifference < accvelocitydifference?
		jz ATXDRV_Type1_BackSlowUseLimit  ;set velocity to exact limit if not

	   fadd [ATXDRV_CurrentVectorVal]
	   fstp [ATXDRV_CurrentVectorVal]      ;add velocity difference for new velocity

      jmp ATXDRV_Type1_NoBackSlow
      ATXDRV_Type1_BackSlowUseLimit:
	   mov eax,[ebx+atxdrv_type1.BackLimit]
	   fstp st0
	   mov [ATXDRV_CurrentVectorVal],eax   ;set new velocity to exact limit
      jmp ATXDRV_Type1_NoBackSlow
      ATXDRV_Type1_BackBrake:
	   fld [ebx+atxdrv_type1.BackSlow]
	   fmul [ATXDRV_KeyTime]
	   fadd [ATXDRV_CurrentVectorVal]
	   fstp [ATXDRV_CurrentVectorVal]
      jmp ATXDRV_Type1_NoBackSlow
      ATXDRV_Type1_NoFrontBackMVTPop2:
	   fstp st0
      ATXDRV_Type1_NoFrontBackMVTPop1:
	   fstp st0
      ATXDRV_Type1_NoBackSlow:

;------------------------
;left/right key mvt
;------------------------
      mov esi,80000000h
      invoke GetAsyncKeyState,[edi+104]   ;left key
      and esi,eax
      invoke GetAsyncKeyState,[edi+112]   ;right key
      and eax,80000000h
      xor eax,esi			  ;only one should be pressed
	  jz ATXDRV_Type1_NoLeftRight

      ;mov [ATXDRV_INITIALVELOCITY.WQuat],1.000000
      ;mov [ATXDRV_INITIALVELOCITY.XQuat],0.000000
      ;mov [ATXDRV_INITIALVELOCITY.YQuat],0.000000
      ;mov [ATXDRV_INITIALVELOCITY.ZQuat],0.000000

      push Temp_Fly_Buffer3		      ;(default/no importance here)
      mov ecx,ATXDRV_INITIALVELOCITY.WQuat    ;source values (current vector quat)
      push ATXDRV_INITVELVECTOR 	      ;param 1 = dest for values
      call CONVERT_TO_FACING_PROC_010	      ;2 params

;make copy of facing values (angle rotation speed)
      mov eax,[ATXDRV_INITVELVECTOR.VectorX]
      mov ecx,[ATXDRV_INITVELVECTOR.VectorY]
      mov edx,[ATXDRV_INITVELVECTOR.VectorZ]
      mov [ATXDRV_INITVELVECTOR_2.VectorX],eax
      mov [ATXDRV_INITVELVECTOR_2.VectorY],ecx
      mov [ATXDRV_INITVELVECTOR_2.VectorZ],edx

;here, if esi = 80000000h, left key was pressed
      test esi,80000000h
	   jz ATXDRV_Type1_assumenegative

;assume positive values
      fld [ATXDRV_INITVELVECTOR.VectorZ]
      fcom [ebx+atxdrv_type1.LeftRightLimit]
      fstsw ax
      test ah,1h
	   jz ATXDRV_Type1_NoLeftRightPop1    ;angular velocity below limit?
      fld [ebx+atxdrv_type1.LeftRight]
      fmul [ATXDRV_KeyTime]
      faddp
      fcom [ebx+atxdrv_type1.LeftRightLimit]
      fstsw ax
      test ah,41h
	   jz ATXDRV_Type1_positiveSpeedOverLimit
      fstp [ATXDRV_INITVELVECTOR.VectorZ]
      jmp ATXDRV_Type1_LeftRightComplete
      ATXDRV_Type1_positiveSpeedOverLimit:
	   mov eax,[ebx+atxdrv_type1.LeftRightLimit]
	   fstp st0
	   mov [ATXDRV_INITVELVECTOR.VectorZ],eax
      jmp ATXDRV_Type1_LeftRightComplete

;right key press (assume negative values)
      ATXDRV_Type1_assumenegative:
      fld [ebx+atxdrv_type1.LeftRightLimit]
      fchs
      fcom [ATXDRV_INITVELVECTOR.VectorZ]
      fstsw ax
      test ah,1h
	   jz ATXDRV_Type1_NoLeftRightPop1    ;angular velocity below limit?
      fld [ebx+atxdrv_type1.LeftRight]
      fmul [ATXDRV_KeyTime]
      fchs		       ;(KeyTime always positive)
      fadd [ATXDRV_INITVELVECTOR.VectorZ]
      fcom st1
      fstsw ax
      test ah,41h
	   jnz ATXDRV_Type1_negativeSpeedOverLimit
      fstp [ATXDRV_INITVELVECTOR.VectorZ]      ;set new angle speed
      fstp st0
      jmp ATXDRV_Type1_LeftRightComplete
      ATXDRV_Type1_negativeSpeedOverLimit:
	   fstp st0
	   fstp [ATXDRV_INITVELVECTOR.VectorZ] ;set angle speed limit
      ;jmp ATXDRV_Type1_LeftRightComplete

;finalize left-right rotational speed values
      ATXDRV_Type1_LeftRightComplete:

;create local quat from Z angle speed variation
      mov ecx,ATXDRV_INITVELVECTOR.VectorZ
      fld DWORD [ecx]
      fsub [ATXDRV_INITVELVECTOR_2.VectorZ]    ;find Z angle speed difference
      mov edx,ATXDRV_TEMPQUAT
      fstp DWORD [ecx]
      call ToLocalQuat_AxisZ

;copy original quat for rot angle speed
      mov eax,[ATXDRV_INITIALVELOCITY.WQuat]
      mov ecx,[ATXDRV_INITIALVELOCITY.XQuat]
      mov [ATXDRV_TEMPQUAT2.QuatW],eax
      mov edx,[ATXDRV_INITIALVELOCITY.YQuat]
      mov eax,[ATXDRV_INITIALVELOCITY.ZQuat]
      mov [ATXDRV_TEMPQUAT2.QuatX],ecx
      mov [ATXDRV_TEMPQUAT2.QuatY],edx
      mov [ATXDRV_TEMPQUAT2.QuatZ],eax

;multiply local quat with original quat or vice-versa
      mov eax,ATXDRV_TEMPQUAT2	  ;original quat
      mov ecx,ATXDRV_TEMPQUAT	  ;local quat
      cmp [ebx+atxdrv_type1.UseQuatMulInvert],0
      mov edx,ATXDRV_INITIALVELOCITY.WQuat
	  jz ATXDRV_Type1_LeftRightNoQuatMulInvert
	  xchg eax,ecx
      ATXDRV_Type1_LeftRightNoQuatMulInvert:

      call QuaternionMul

      mov [ATXDRV_INITIALVELOCITY.WQuat],0.000000
      mov [ATXDRV_INITIALVELOCITY.XQuat],0.000000
      mov [ATXDRV_INITIALVELOCITY.YQuat],0.000000
      mov [ATXDRV_INITIALVELOCITY.ZQuat],0.500000

      jmp ATXDRV_Type1_NoLeftRight
      ATXDRV_Type1_NoLeftRightPop2:
	   fstp st0
      ATXDRV_Type1_NoLeftRightPop1:
	   fstp st0
      ATXDRV_Type1_NoLeftRight:

;------------------------
;calculate vector based on object's direction to add to velocity, using unit vector
;------------------------
      fld [ATXDRV_CurrentVectorVal]
      fsub [ATXDRV_CurrentVectorVal_Saved]
      fld st0
      fmul [ATXDRV_CurrentVectorDir+0]
      fadd [ATXDRV_INITIALVELOCITY.XVelocity]
      fstp [ATXDRV_INITIALVELOCITY.XVelocity]
      fld st0
      fmul [ATXDRV_CurrentVectorDir+4]
      fadd [ATXDRV_INITIALVELOCITY.YVelocity]
      fstp [ATXDRV_INITIALVELOCITY.YVelocity]
      fmul [ATXDRV_CurrentVectorDir+8]
      fadd [ATXDRV_INITIALVELOCITY.ZVelocity]
      fstp [ATXDRV_INITIALVELOCITY.ZVelocity]

;------------------------
;set new velocity values
;------------------------
      ;mov [ATXDRV_INITIALVELOCITY.XVelocity],1.000000
      ;mov [ATXDRV_INITIALVELOCITY.YVelocity],0.000000
      ;mov [ATXDRV_INITIALVELOCITY.ZVelocity],0.000000

      mov eax,[ebx+atxdrv_type1.Instance]
      push ATXDRV_INITIALVELOCITY
      mov edx,[eax+28h]
      push eax
      mov ecx,[edx+0Ch]
      call SetInstancePhysicsVelocity

NO_ATXDRV_KEYHANDLER_TYPE1:
ret

ATXDRV_Type1_Unfreeze:

      mov eax,[ebx+atxdrv_type1.Instance]
      push ATXDRV_INITIALVELOCITY
      mov edx,[eax+28h]
      push eax
      mov ecx,[edx+0Ch]
      call SetInstancePhysicsUnfreezeOnly

ret

;========================================================
;include 'ATXDRV_TYPE0_OLD.inc'
;========================================================

