;===============================================================
;KEY INTERCEPTION/HANDLING
;===============================================================
;NOTE: For all general movement keys, the game DOES NOT process
;the WM_KEYDOWN, WM_KEYUP, or WM_CHAR messages.
;
;-> General movement keys are scanned using a call to GetAsyncKeyState,
; referenced nearest to the end of the executable (005DBCE2 for
; P6 1.1 exe).
;-> Console/command-line (i.e., saving) keys are processed from
; the WM_CHAR message.
;-> General system keys (ESC, PrintScreen, F11, etc.) are scanned
; from the WM_KEYDOWN message.
;===============================================================

;===============================================================
INTERCEPTPROC WM_CHARHANDLERPROC	;WM_CHAR HANDLER
;===============================================================
;WNDPROC params start at [esp+10h]

movsx edx,WORD [esp+1Ch]	;replaced code
mov eax,[esp+18h]		;replaced code (eax=wparam=char)
push eax
push ecx
push edx

cmp [IsInGame_BOOL],0
     jz MAIN_KEYHANDLER_EXIT

	TESTKEY [UseToggleNewKeys],ToggleNewKeys_359324
	cmp [ToggleNewKeys_BOOL],0
	    jz NoNewKeys_43554

cmp [IsInConsole_BOOL],1
     jz MAIN_KEYHANDLER_EXIT

	TESTKEY [UseDrawDistSubKey],SubstractFromDrawDist_343
	TESTKEY [UseDrawDistAddKey],AddToDrawDist_343
	TESTKEY [UseATXDRVEscKey],ExitATXDRVMode_32434
	TESTKEY [LINST_cycleleftkey],LINST_cycleleftkeypressed
	TESTKEY [LINST_cyclerightkey],LINST_cyclerightkeypressed
	TESTKEY [LINST_cyclepreviouskey],LINST_cyclepreviouskeypressed
	TESTKEY [THIRDP_keyaimtoggle],THIRDP_ToggleAimKeyCHAR
	TESTKEY [THIRDP_keyaimdottoggle],THIRDP_ToggleAimDotKeyCHAR

   ;New Hotkeys loop (does not modify eax unless finds match)
	push esi
	mov esi,CheatHotKeyTableRT
	WM_CHARHANDLERPROC_NewHotkeysLoop:
	mov edx,[esi+CheatHotKeyTableEntry.KeyValue]
	test edx,edx
	     jz WM_CHARHANDLERPROC_NewHotkeysLoopEnd
	cmp eax,edx
	    jz NewHotKeysScan_MatchFound
	add esi,sizeof.CheatHotKeyTableEntry
	jmp WM_CHARHANDLERPROC_NewHotkeysLoop

	WM_CHARHANDLERPROC_NewHotkeysLoopEnd:
	pop esi


NoNewKeys_43554:

MAIN_KEYHANDLER_EXIT:
pop edx
pop ecx
pop eax
ret

;===============================================================
ToggleNewKeys_359324:
	xor [ToggleNewKeys_BOOL],1
	invoke GetTickCount
	mov [ToggleKeysShowStateTime],eax
	;...
;===============================================================
EXITKEYHANDLER:
	pop edx
	pop ecx
	pop eax
	add esp,4		;get rid of return address
	pop edi
	xor eax,eax
	pop esi
	ret 10h

EXITKEYHANDLER_PASSIVE:
	pop edx
	pop ecx
	pop eax
	ret
;===============================================================
NewHotKeysScan_MatchFound:
	mov ecx,[esi+CheatHotKeyTableEntry.ProcAddress]
	pop esi
	call EXECUTECHEATCODE		;simulate cheat call without params
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
SubstractFromDrawDist_343:
	push DWORD -1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
AddToDrawDist_343:
	push DWORD 1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ExitATXDRVMode_32434:
	call AT108MAIN
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
THIRDP_ToggleAimKeyCHAR:
	xor [THIRDP_keyaimtoggle_ON],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
THIRDP_ToggleAimDotKeyCHAR:
	xor [THIRDPAIM_enabled],1
jmp EXITKEYHANDLER_PASSIVE

;===============================================================
INTERCEPTPROC WM_KEYDOWNHANDLERPROC	;WM_KEYDOWN HANDLER
;===============================================================
;this code is used to disable certain keys' disabling and to
;test if we are in-game, in menu, at console, etc.

mov eax,[esp+1Ch]	;REPLACED CODE
mov edx,[esp+18h]

	cmp edx,VK_ESCAPE
	    jz Keydown_ESC_Press       ;game menu
	cmp edx,VK_F1
	    jz Keydown_F1_Press        ;hint menu
	cmp edx,VK_F11
	    jz Keydown_F11_Press       ;console key (second part)
	cmp edx,VK_F12
	    jz Keydown_F12_Press       ;game controls menu

mov edx,eax		;REPLACED CODE
ret

;===============================================================
Keydown_ESC_Press:
	call StartInGameMenuTimer
	mov [IsInConsole_BOOL],0      ;must be BEFORE StartInGameMenuTimer call
	mov [IsInGame_BOOL],0	      ;must be AFTER StartInGameMenuTimer call
mov edx,eax		;REPLACED CODE
ret
;===============================================================
Keydown_F1_Press:
	cmp [IsInConsole_BOOL],0	  ;only start not-in-game tick if not in console
					  ;(because this key does not close console)
	    jnz NoStartInGameMenuTimer_Keydown_F1_Press
	call StartInGameMenuTimer
	NoStartInGameMenuTimer_Keydown_F1_Press:

	mov [IsInGame_BOOL],0	      ;must be AFTER StartInGameMenuTimer call
mov edx,eax		;REPLACED CODE
ret
;===============================================================
Keydown_F12_Press:
	cmp [IsInConsole_BOOL],0	  ;only start not-in-game tick if not in console
					  ;(because this key does not close console)
	    jnz NoStartInGameMenuTimer_Keydown_F12_Press
	call StartInGameMenuTimer
	NoStartInGameMenuTimer_Keydown_F12_Press:

	mov [IsInGame_BOOL],0	      ;must be AFTER StartInGameMenuTimer call
mov edx,eax		;REPLACED CODE
ret
;===============================================================
Keydown_F11_Press:
	mov [IsInConsole_BOOL],0
mov edx,eax		;REPLACED CODE
ret


;===============================================================
INTERCEPTPROC CONSOLE_OPEN_KEYS_PRESSED
;===============================================================
;if CTRL is pressed,
cmp [IsInGame_BOOL],0		;usually follows Keydown_F11_Press
    jz NO_CONSOLE_OPEN_KEYS_PRESSED
    xor [IsInConsole_BOOL],1
NO_CONSOLE_OPEN_KEYS_PRESSED:

mov ecx,[esi+38h]	 ;REPLACED CODE
mov eax,[ecx]		 ;REPLACED CODE
call DWORD [eax+28h]	 ;REPLACED CODE
ret
;===============================================================