;============================================================
;LEVEL SAVING CODE
;============================================================
ATX_QUICKSAVE_RT:
push ebx

	invoke GetTickCount
	mov ebx,eax
	sub eax,[QUICKSAVE_tick]
	cmp eax,QUICKSAVE_INTERVAL
	    jb NoATX_QUICKSAVE_RT

	mov [QUICKSAVE_savedone_BOOL],0

	invoke GetAsyncKeyState,QUICKSAVE_KEY
	test eax,80000000h
	     jz NoATX_QUICKSAVE_RT_B

	call QuickSaveMainProc
	test eax,eax
	mov [QUICKSAVE_tick],ebx
	mov [QUICKSAVE_savedone_BOOL],1
	    jnz QuickSaveMainProcCallANoError
	    mov [QUICKSAVE_savedone_BOOL],2
	QuickSaveMainProcCallANoError:

NoATX_QUICKSAVE_RT_B:
pop ebx
ret



NoATX_QUICKSAVE_RT:
	cmp [QUICKSAVE_savedone_BOOL],FALSE
	    jz NoDisplayLevelSavedMessageCallA
	    call DisplayLevelSavedMessageRT
	NoDisplayLevelSavedMessageCallA:

pop ebx
ret

;============================================================
DisplayLevelSavedMessageRT:
;============================================================

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	mov eax,QUICKSAVE_levelsave_STR
	cmp [QUICKSAVE_savedone_BOOL],2
	mov edx,(QUICKSAVE_levelsave_STR_END-QUICKSAVE_levelsave_STR-1)
	    jnz DisplayLevelSavedMessageRTNotError
	    mov eax,QUICKSAVE_levelsave_err_STR
	    mov edx,(QUICKSAVE_levelsave_err_STR_END-QUICKSAVE_levelsave_err_STR-1)
	DisplayLevelSavedMessageRTNotError:

invoke TextOut,edi,0,0,eax,edx

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

ret

;============================================================
QuickSaveMainProc:	   ;returns null in eax if error, non-zero if success
;============================================================
;destroyed: eax,ecx,edx
push edi
push esi

;delete current quick save file if existing
	cmp DWORD [QUICKSAVE_currentfilename],'none'
	    jz NoDeleteCurrentQuickSaveFile
	    mov esi,QUICKSAVE_currentfilename
	    mov edi,[PathStringSize]
	    add edi,StringBuffer
	    call TransferString
	    invoke DeleteFile,StringBuffer
	    mov ecx,[PathStringSize]
	    mov BYTE [ecx+StringBuffer],0
	NoDeleteCurrentQuickSaveFile:

;get name of savegame that should be created next
	stdcall FindNextSaveGameFileName,QUICKSAVE_currentfilename

;save savegame name to ATXconfig.ini
	invoke WritePrivateProfileString,section_gamesaving,key_qscurrentfile,QUICKSAVE_currentfilename,ATXconfiginiFN

;emulate ActionType 19 to save level
	mov ecx,AT19EMULATEDOBJECT
	mov eax,[ecx]
	mov DWORD [ecx+4],0
	mov DWORD [ecx+8],(QUICKSAVE_filedisplayname_STR_END-QUICKSAVE_filedisplayname_STR-1)
	mov DWORD [ecx+0Ch],010h
	mov DWORD [ecx+20h],QUICKSAVE_filedisplayname_STR
	call DWORD [eax+8]

	mov eax,1
pop esi
pop edi
ret

