;=====================================================
;create map index save file for savegame
;=====================================================


;[DWORD [CPARTICLESBUFADDRVAR] - 16] = pointer to list of
;particle name objects (size = 6 DWORDS) - Type ID is member +16
;[DWORD [CPARTICLESBUFADDRVAR] + 4] = number of CParticle objects

;SAVEDMAP.xxx format (starting at offset 0):
;
;16 bytes       - 2D Map X-Y position values (4 32-bit floats)
;80 bytes       - 2D Map BMP name (*.bmp+null-terminator)
;4 bytes        - Game speed value (32-bit float)
;4 bytes        - Number of bytes in "current hint" string (0 if none)
;variable       - "current hint" string

;=====================================================
INTERCEPTPROC SAVE_SAVED_MAP_STATE   ;ebx = file handle
;=====================================================
mov edx,[esp+1E4h]	;REPLACED CODE (7 bytes)
			;edx = pointer to SAVEGAME.xxx filename + path
push ebx
push ecx
push esi
push edi
xor ebx,ebx

	mov esi,edx
	mov edi,SAVEGAMENAME_BUFFER
	call TransferString
;=====================================================

cmp DWORD [edi-4],'.scx'
    jz NO_SAVEMAP_SAVE_A
cmp DWORD [edi-4],'.SCX'
    jz NO_SAVEMAP_SAVE_A

mov DWORD [edi-8],'DMAP'	;'SAVEGAME' replaced by 'SAVEDMAP'

invoke DeleteFile,SAVEGAMENAME_BUFFER	;delete "SAVEDMAP.xxx" if existing

cmp [currentbitmap],0			;if no map, make sure to write only null characters
    jnz NO_MAP_SAVE_NULLIFY_1
	push edi
	xor eax,eax
	mov edi,CURRENT_MAP_VALUES
	mov ecx,4
	rep stosd
	mov edi,CURRENT_MAP_BUFFER
	mov ecx,20
	rep stosd
	pop edi
NO_MAP_SAVE_NULLIFY_1:

invoke CreateFile,SAVEGAMENAME_BUFFER,GENERIC_WRITE,0,0,\
		CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	test eax,eax
	     jz SAVED_FILE_LOAD_FAIL2
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL2
	mov ebx,eax

invoke SetFilePointer,eax,0,0,FILE_BEGIN
	cmp eax,-1
	    jz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE MAP POSITION VALUES
;------------------------------------------
	sub esp,4
	mov eax,esp		;write POSITION values
invoke WriteFile,ebx,CURRENT_MAP_VALUES,16,eax,0
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,16
	    jnz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE 2D MAP NAME
;------------------------------------------
	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,CURRENT_MAP_BUFFER,80,eax,0    ;write BITMAP NAME
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,80
	    jnz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE CURRENT GAME SPEED
;------------------------------------------
	mov eax,[NormalGameSpeed]
	mov DWORD [stack_ext_buffer],eax

	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,4,eax,0	 ;write GAME SPEED
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,4
	    jnz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
;SAVE CURRENT HINT (IF AT106-TYPE)
;------------------------------------------
mov edx,[CURRENT_HINT_ID_ADDR]
mov eax,[HINT_NEW_STRING_ADDR]
cmp DWORD [edx],NEW_HINT_TYPE_ID
    jnz NoSaveCurrentHint_SAVEGAME
test eax,eax
     jz NoSaveCurrentHint_SAVEGAME

	mov edi,eax
	FINDSTRINGEND edi
	sub edi,eax
	inc edi

	sub esp,4
	mov DWORD [stack_ext_buffer],edi
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,4,eax,0	 ;write HINT string length
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,4
	    jnz SAVED_FILE_LOAD_FAIL2

	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,[HINT_NEW_STRING_ADDR],edi,eax,0	 ;write HINT string
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,edi
	    jnz SAVED_FILE_LOAD_FAIL2

jmp SaveCurrentHint_SAVEGAME_OK

NoSaveCurrentHint_SAVEGAME:
	sub esp,4
	mov DWORD [stack_ext_buffer],0
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,4,eax,0	 ;write HINT string length as NULL
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,4
	    jnz SAVED_FILE_LOAD_FAIL2

SaveCurrentHint_SAVEGAME_OK:

;------------------------------------------
;BUILD AND SAVE AT110 DATA BUFFER
;------------------------------------------
push esi

	mov esi,[FIXS_mainbuffer]
	xor ecx,ecx
	test esi,esi
	mov edi,[FIXS_mainbuffer_sizediv2]
	     jz NoSaveAT110ToSAVEDMAP

	xor eax,eax
	SaveAT110ToSAVEDMAP_LOOP:
	cmp [esi],eax
	    jz SaveAT110ToSAVEDMAP_LOOP_NoID
	    inc ecx
	SaveAT110ToSAVEDMAP_LOOP_NoID:
	add esi,4
	cmp esi,[FIXS_mainbuffer_halfend]
	    jb SaveAT110ToSAVEDMAP_LOOP
	test ecx,ecx
	     jz NoSaveAT110ToSAVEDMAP

	mov eax,(4+sizeof.at110proj_info)
	mul ecx
	lea ecx,[eax+8] 		;add space for struc size and AT110 version ID
NoSaveAT110ToSAVEDMAP:	      ;...but must still write null size count

pop esi

	sub esp,4
	mov DWORD [stack_ext_buffer],ecx
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,4,eax,0	 ;write total buffer length
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,4
	    jnz SAVED_FILE_LOAD_FAIL2

	mov ecx,DWORD [stack_ext_buffer]
	test ecx,ecx
	     jz NoSaveAT110ToSAVEDMAP_2

invoke LocalAlloc,LMEM_FIXED,ecx
	test eax,eax
	mov edi,eax
	     jz SAVED_FILE_LOAD_FAIL2

;generate temporary buffer to write
push ebx
push ebp
push esi
push edi

	mov DWORD [edi],AT110_VERSION_ID
	mov DWORD [edi+4],sizeof.at110proj_info
	add edi,8

;BUFFER FORMAT: AT110 Version ID, at110proj_info structure size,
;               instance name ID, structure, instance name ID, structure, etc.

	mov esi,[FIXS_mainbuffer]
	mov ebx,[FIXS_mainbuffer_sizediv2]

	SaveAT110ToSAVEDMAP_LOOP_2:
	mov eax,[esi]
	test eax,eax
	     jz SaveAT110ToSAVEDMAP_LOOP_2_skip1
	     mov [edi],eax		     ;copy name ID
	     add edi,4
	     push esi
	     mov esi,[esi+ebx]
	     mov ecx,(sizeof.at110proj_info)
	     rep movsb			     ;copy structure
	     pop esi
	SaveAT110ToSAVEDMAP_LOOP_2_skip1:
	add esi,4
	cmp esi,[FIXS_mainbuffer_halfend]
	    jb SaveAT110ToSAVEDMAP_LOOP_2

pop edi
pop esi
pop ebp
pop ebx

	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,edi,DWORD [stack_ext_buffer],eax,0    ;write final buffer
	push eax
	  invoke LocalFree,edi
	pop eax
	pop ecx
	test eax,eax
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,DWORD [stack_ext_buffer]
	    jnz SAVED_FILE_LOAD_FAIL2

NoSaveAT110ToSAVEDMAP_2:

;------------------------------------------
;SAVE AT112- AND AT113-SET VALUES
;------------------------------------------

	xor ecx,ecx
	mov cl,[AT113_PLAYER_AITYPE_NON5_SET]
	mov eax,[AT112_InputTogglerID]
	mov DWORD [stack_ext_buffer],ecx
	mov DWORD [stack_ext_buffer+8],eax

	call GetPlayerPrivAIType
	mov DWORD [stack_ext_buffer+4],eax

	sub esp,4
	mov eax,esp
invoke WriteFile,ebx,stack_ext_buffer,12,eax,0	  ;write total buffer length
	test eax,eax
	pop ecx
	    jz SAVED_FILE_LOAD_FAIL2
	cmp ecx,12
	    jnz SAVED_FILE_LOAD_FAIL2

;------------------------------------------
SAVED_FILE_LOAD_FAIL2:
;------------------------------------------
	CLOSEHANDLE ebx

NO_SAVEMAP_SAVE_A:

pop edi
pop esi
pop ecx
pop ebx

mov edx,[esp+1E4h]	;restore edx
ret